blob: d702e8a38f95397dc4eab7c9e9d2d96df5f7b7fb [file] [log] [blame]
Michael Blow6214f6f2016-08-31 03:03:00 -04001#!/bin/bash
2# ------------------------------------------------------------
3# Licensed to the Apache Software Foundation (ASF) under one
4# or more contributor license agreements. See the NOTICE file
5# distributed with this work for additional information
6# regarding copyright ownership. The ASF licenses this file
7# to you under the Apache License, Version 2.0 (the
8# "License"); you may not use this file except in compliance
9# with the License. You may obtain a copy of the License at
10#
11# http://www.apache.org/licenses/LICENSE-2.0
12#
13# Unless required by applicable law or agreed to in writing,
14# software distributed under the License is distributed on an
15# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
16# KIND, either express or implied. See the License for the
17# specific language governing permissions and limitations
18# under the License.
19# ------------------------------------------------------------
20
Michael Blowfec04f02016-10-27 21:15:20 -040021function usage() {
22 echo
23 echo Usage: $(basename $0) [-f[orce]]
24 echo
25 echo " -f[orce] : Forces a start attempt when ${PRODUCT} processes are found to be running"
26}
27
28while [ -n "$1" ]; do
29 case $1 in
30 -f|-force) force=1;;
31 -help|--help|-usage|--usage) usage; exit 0;;
32 *) echo "ERROR: unknown argument '$1'"; usage; exit 1;;
33 esac
34 shift
35done
36
Michael Blow6214f6f2016-08-31 03:03:00 -040037if [ -z "$JAVA_HOME" -a -x /usr/libexec/java_home ]; then
38 JAVA_HOME=$(/usr/libexec/java_home)
39 export JAVA_HOME
40fi
41
42[ -z "$JAVA_HOME" ] && {
43 echo "JAVA_HOME not set"
44 exit 1
45}
46"$JAVA_HOME/bin/java" -version 2>&1 | grep -q '1\.[89]' || {
47 echo "JAVA_HOME must be at version 1.8 or later:"
48 "$JAVA_HOME/bin/java" -version
49 exit 2
50}
51DIRNAME=$(dirname $0)
52[ $(echo $DIRNAME | wc -l) -ne 1 ] && {
53 echo "Paths with spaces are not supported"
54 exit 3
55}
56
57CLUSTERDIR=$(cd $DIRNAME/..; echo $PWD)
58INSTALLDIR=$(cd $CLUSTERDIR/../..; echo $PWD)
59LOGSDIR=$CLUSTERDIR/logs
60
61echo "CLUSTERDIR=$CLUSTERDIR"
62echo "INSTALLDIR=$INSTALLDIR"
Michael Blowfdcf0552016-09-25 22:18:27 -040063echo "LOGSDIR=$LOGSDIR"
Michael Blow6214f6f2016-08-31 03:03:00 -040064echo
65cd $CLUSTERDIR
66mkdir -p $LOGSDIR
67$INSTALLDIR/bin/${HELPER_COMMAND} get_cluster_state -quiet \
68 && echo "ERROR: sample cluster address (localhost:${LISTEN_PORT}) already in use" && exit 1
69
Michael Blowfec04f02016-10-27 21:15:20 -040070if $JAVA_HOME/bin/jps | grep ' \(CCDriver\|NCDriver\|NCService\)$' > /tmp/$$_jps; then
71 if [ $force ]; then
72 severity=WARNING
73 else
74 severity=ERROR
75 fi
76 echo -n "${severity}: ${PRODUCT} processes are already running; "
77 if [ $force ]; then
78 echo "-f[orce] specified, ignoring"
79 else
80 echo "aborting"
81 echo
82 echo "Re-run with -f to ignore, or run stop-sample-cluster.sh -f to forcibly terminate all running ${PRODUCT} processes:"
83 cat /tmp/$$_jps | sed 's/^/ - /'
84 rm /tmp/$$_jps
85 exit 1
86 fi
87fi
88
89rm /tmp/$$_jps
Michael Blow6214f6f2016-08-31 03:03:00 -040090(
91 echo "--------------------------"
92 date
93 echo "--------------------------"
94) | tee -a $LOGSDIR/blue-service.log | tee -a $LOGSDIR/red-service.log >> $LOGSDIR/cc.log
Michael Blowfec04f02016-10-27 21:15:20 -040095echo "INFO: Starting sample cluster..."
Michael Blow6214f6f2016-08-31 03:03:00 -040096$INSTALLDIR/bin/${NC_SERVICE_COMMAND} -logdir - -config-file $CLUSTERDIR/conf/blue.conf >> $LOGSDIR/blue-service.log 2>&1 &
97$INSTALLDIR/bin/${NC_SERVICE_COMMAND} -logdir - >> $LOGSDIR/red-service.log 2>&1 &
98$INSTALLDIR/bin/${CC_COMMAND} -config-file $CLUSTERDIR/conf/cc.conf >> $LOGSDIR/cc.log 2>&1 &
Michael Blowfdcf0552016-09-25 22:18:27 -040099$INSTALLDIR/bin/${HELPER_COMMAND} wait_for_cluster -timeout 30
100exit $?